package main

import (
    "log"
    "time"

    "github.com/bwmarrin/discordgo"
)

func ping(s *discordgo.Session, i *discordgo.InteractionCreate) {
    if i.Interaction.Member != nil {
        log.Printf("%s#%s invoked ping command", i.Interaction.Member.User.Username, i.Interaction.Member.User.Discriminator)
    } else if i.Interaction.User != nil {
        log.Printf("%s#%s invoked ping command", i.Interaction.User.Username, i.Interaction.User.Discriminator)
    }
    s.InteractionRespond(i.Interaction, &discordgo.InteractionResponse{
        Type: discordgo.InteractionResponseChannelMessageWithSource,
        Data: &discordgo.InteractionResponseData{
            //Flags:   1 << 6, // Only lets issuer see initial response
            Content: "Pong!",
        },
    })
}

func sping(s *discordgo.Session, i *discordgo.InteractionCreate) {
    if i.Interaction.Member != nil {
        log.Printf("%s#%s invoked ping command", i.Interaction.Member.User.Username, i.Interaction.Member.User.Discriminator)
    } else if i.Interaction.User != nil {
        log.Printf("%s#%s invoked ping command", i.Interaction.User.Username, i.Interaction.User.Discriminator)
    }
    s.InteractionRespond(i.Interaction, &discordgo.InteractionResponse{
        Type: discordgo.InteractionResponseChannelMessageWithSource,
        Data: &discordgo.InteractionResponseData{
            Flags:   1 << 6, // Only lets issuer see initial response
            Content: "Pong!",
        },
    })
}

func slowping(s *discordgo.Session, i *discordgo.InteractionCreate) {
    if i.Interaction.Member != nil {
        log.Printf("%s#%s invoked ping command", i.Interaction.Member.User.Username, i.Interaction.Member.User.Discriminator)
    } else if i.Interaction.User != nil {
        log.Printf("%s#%s invoked ping command", i.Interaction.User.Username, i.Interaction.User.Discriminator)
    }
    s.InteractionRespond(i.Interaction, &discordgo.InteractionResponse{
        Type: discordgo.InteractionResponseChannelMessageWithSource,
        Data: &discordgo.InteractionResponseData{
            //Flags:   1 << 6, // Only lets issuer see initial response
            Content: "...",
        },
    })

    time.Sleep(time.Second * 10)

    _, err := s.FollowupMessageCreate(i.Interaction, true, &discordgo.WebhookParams{
        Content: "Pong!",
    })
    if err != nil {
        log.Println(err)
    }
}
